=== test/fakelinux/arch/arc/Makefile ===
IMAGE = uImage.gz
COMPRESS = gzip -n
ARCHDIRNAME = arc
