=== test/fakelinux/arch/arm/Makefile ===
IMAGE = zImage
COMPRESS = bzip2
ARCHDIRNAME = arm
