=== test/fakelinux/arch/arm64/Makefile ===
IMAGE = Image.gz
COMPRESS = gzip -n
ALT_IMAGE = Image.bz2
ALT_COMPRESS = bzip2
ARCHDIRNAME = arm64
