=== test/fakelinux/arch/hexagon/Makefile ===
IMAGE = zImage
COMPRESS = bzip2
ARCHDIRNAME = hexagon
