=== test/fakelinux/arch/i386/Makefile ===
IMAGE = bzImage
COMPRESS = bzip2
ARCHDIRNAME = x86
