=== test/fakelinux/arch/mips/Makefile ===
IMAGE = uImage.gz
COMPRESS = gzip -n
ARCHDIRNAME = mips
