=== test/fakelinux/arch/parisc/Makefile ===
IMAGE = bzImage
COMPRESS = bzip2
ARCHDIRNAME = parisc
