=== test/fakelinux/arch/powerpc/Makefile ===
IMAGE = zImage
COMPRESS = bzip2
ARCHDIRNAME = powerpc
