=== test/fakelinux/arch/riscv/Makefile ===
IMAGE = Image.gz
COMPRESS = gzip -n
ARCHDIRNAME = riscv
