=== debian/changelog ===
tuxmake (1.7.0-1) UNRELEASED; urgency=medium

  * Initial release

 -- Antonio Terceiro <antonio.terceiro@linaro.org>  Wed, 23 Dec 2020 17:26:49 -0300
