=== debian/control ===
Source: tuxmake
Maintainer: Antonio Terceiro <antonio.terceiro@linaro.org>
Section: python
Priority: optional
Build-Depends: bash-completion,
               debhelper-compat (= 13),
               dh-python,
               flit,
               git,
               wget,
               pybuild-plugin-pyproject,
               python3-all,
               python3-pytest,
               python3-pytest-cov,
               python3-pytest-mock
Standards-Version: 3.9.6
Homepage: https://tuxmake.org/

Package: tuxmake
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}, python3 (>= 3.6), ${python3:Depends}
Recommends: socat
Description: Thin wrapper to build Linux kernels
 TuxMake is a command line tool and Python library that provides portable and
 repeatable Linux kernel builds across a variety of architectures, toolchains,
 kernel configurations, and make targets.
